

;                        DuckHunt 83 for Ion
;                        (v1.0c) oooooooooooo
;                        oooooooooooooooooooo
;
;                     Original : Andrew Ungvarsky
;                      Ti-82 Port: Ahmed El-Helw
;                          Ion Port : Kaid


#DEFINE TITRE "DuckHunt 83", 0
.INCLUDE ZSHELL83.INC

DUCKX   = saferam3
DUCKY   = saferam3+1
WING    = saferam3+2
DIRLR   = saferam3+3
DIRUD   = saferam3+4
MOVES   = saferam3+5
GUNX    = saferam3+6
GUNY    = saferam3+7
CURDUCK = saferam3+8 
DHIT    = saferam3+9
ROUND   = saferam3+10
BULLETS = saferam3+11
NEEDED  = saferam3+12
SCORE   = saferam3+13
DLAY    = saferam3+15
NOLET   = saferam3+17
STRING  = saferam3+27


        CALL Intro                      ;Display intro


; o Title Loop o

TitleLoop:
        bcall(GET_KEY)                  ;Wait for a key

        OR A
        JR Z,TitleLoop

        CP G_MODE                       ;Quit ?
        RET Z

        CP G_ENTER                      ;Start the game ?
        JR NZ,TitleLoop


; o Start game o
Start:
        CALL varInit                    ;Init var

NewRound:
        SET 7,(IY+$14)                  
        CALL nrInit                     ;Init new round

NewDuck:
        CALL ndInit                     ;Init new duck

; o Game Loop o
Loop:

        SET 7,(IY+$14)                  
        LD HL,57*256+59                 ;
        LD (CURSOR_X),HL                ;
        LD HL,(SCORE)                   ;
        CALL DispHL                     ;Display the score

        call LoadDuck                   ;Loads the Duck
        call DrawDuck                   ;Draw the Duck
        bcall(_copygbuf)                ;Copy graph buffer to screen

GetKeyLoop:

        LD B,$FE                        ;Load desired port
        CALL KeyStuff                   ;
                                        
        CP 251                          ;
        JR Z,GunRight                   ;Key=Right

        CP 253                          ;
        JR Z,GunLeft                    ;Key=Left

        CP 247                          ;
        JR Z,GunUp                      ;Key=Up

        CP 254                          ;
        JR Z,GunDown                    ;Key=Down 

        LD B,$BF                        ;Load desired port
        CALL KeyStuff                   ;

        CP 223                          ;
        JP Z,shoot                      ;Key=2ND (Shoot)

        CP 127                          ;
        CALL Z,Pause                    ;Key=DEL (Pause)

        CP 191                          ;
        JP Z,exit                       ;Key=MODE (Exit)

        JP NoKey                        ;NoKey Otherwise


; o Move gun up o
GunUp:
        LD A,(GUNY)                     ;gun y-coord->a
        OR A                            ;a=0? (top of screen?)
        JR Z,NoKey                      ;if so, NoKey
        CALL PutGun
        LD A,(GUNY)                     ;gun y-coord->a
        DEC A \ DEC A                   ;a-2->a (to move up)
        LD (GUNY),A                     ;a->gun y-coord
        JP PutMove                      ;put gun move

; o Move gun down o
GunDown:
        LD A,(GUNY)                     ;gun y-coord->a
        CP 38                           ;a=38? (grass line?)
        JR Z,NoKey                      ;if so, goto NoKey
        CALL PutGun
        LD A,(GUNY)                     ;gun y-coord->a
        INC A \ INC A                   ;a+2->a (to move down)
        LD (GUNY),A                     ;a->gun y-coord
        JP PutMove                      ;put gun move
         
; o Move gun left o
GunLeft:
        LD A,(GUNX)                     ;gun x-coord->a
        OR A                            ;a=0? (left side of screen)
        JR Z,NoKey                      ;if so, goto NoKey
        CALL PutGun
        LD A,(GUNX)                     ;gun x-coord->a
        DEC A \ DEC A                   ;a-2->a (to move left)
        LD (GUNX),A                     ;a->gun x-coord
        JP PutMove                      ;put gun move

; o Move gun right o
GunRight:
        LD A,(GUNX)                     ;gun x-coord->a
        CP 88                           ;a=88? (right side of screen)
        JR Z,NoKey                      ;if so, goto NoKey
        CALL PutGun
        LD A,(GUNX)                     ;gun x-coord->a
        INC A \ INC A                   ;a+2->a (to move right)
        LD (GUNX),A                     ;a->gun x-coord
        JP PutMove                      ;Put GunMove

; o No Key o
NoKey:
        LD B,1 \ CALL Delay             ;Delay
        JP SkipDelay


; o Duck fly away o
flyaway:
        CALL erdc                       ;erase duck and cursor

        LD HL,20*256+34                 ;penrow=20,pencol=34
        LD (CURSOR_X),HL                ;set these coords
        LD HL,fas                       ;fly away STRING
        bcall(D_ZM_STR)

flyaway1:
        LD IX,faway                     ;faway sprite->ix
        CALL DrawDuck                   ;Draw the Duck
        bcall(_copygbuf)                ;Copy graph buffer to screen

        LD B,1 \ CALL Delay             ;Delay

        LD IX,faway                     ;faway sprite->bc
        CALL DrawDuck                   ;Draw the Duck
        bcall(_copygbuf)                ;Copy graph buffer to screen

        LD A,(DUCKY)                    ;duck y-coord->a
        OR A                            ;top of the screen? (a=0?)
        JR Z,advance                    ;if so, goto fadvance
        DEC A                           ;a-1->a (to decrease y-coord)
        LD (DUCKY),A                    ;a->duck y-coord
        JP flyaway1                     ;loop!


; o A HIT!!! o
hit:
        CALL erdc                       ;erase duck and cursor!

        LD A,(DHIT)                     ;ducks hit->a
        INC A                           ;a+1->a
        LD (DHIT),A                     ;a->ducks hit

; o Update SCORE o

        LD A,(BULLETS)                  ;BULLETS remaining->a
        LD H,A
        LD L,15
        bcall(_htimesl)

        LD DE,(SCORE)
        ADD HL,DE
        LD (SCORE),HL                   ;Update score

hitloop:

        LD IX,hitduck                   ;sprite hitduck->bc
        CALL DrawDuck                   ;Draw the Duck
        bcall(_copygbuf)                ;Copy graph buffer to screen        

        LD B,1 \ CALL Delay             ;Delay
        LD IX,hitduck                   ;sprite hitduck->bc
        CALL DrawDuck                   ;Draw the Duck
        bcall(_copygbuf)                ;Copy graph buffer to screen

        LD A,(DUCKY)                    ;duck y-coord->
        INC A                           ;a+1->a (make him go one more down the screen)
        LD (DUCKY),A                    ;a->duck y-coord

        CP 38                           ;grass line?
        JR NZ,hitloop

; advance duck, ROUND, or even END of game
advance:                                
        LD A,(CURDUCK)                  ;current duck #->a
        CP 10                           ;duck #10? (new ROUND?)
        JP Z,rndovr                     ;if so, goto ROUND over
        INC A                           ;a+1->a (increase current duck #)
        LD (CURDUCK),A                  ;a->current duck #
        JP NewDuck                      ;new duck!



; o Subtract bullet from remaining o
subbull:
        LD A,(BULLETS)                  ;BULLETS left->a
        DEC A                           ;a-1->a
        LD (BULLETS),A                  ;a->BULLETS
        OR A                            ;zero? (out of BULLETS?)
        JP Z,flyaway                    ;if so, goto flyaway!
        JP NoKey                        ;return from getkey


; o Move duck o
dmove:
        LD A,(MOVES)                    ;MOVES->a
        INC A                           ;a+1->a
        LD (MOVES),A                    ;a->MOVES
        LD A,(DIRLR)                    ;DIRLR->a

        CP 1                            ;is duck moving right?
        JR Z,inca                       ;if so, increment DUCKX

        LD A,(DUCKX)                    ;DUCKX->a
        DEC A                           ;a-1->a

rinc:					;return from inc
        LD (DUCKX),A                    ;a->DUCKX
        LD A,(DIRUD)                    ;DIRUD->a

        CP 1                            ;is duck moving up?
        JR Z,deca                       ;if so, goto decrement a

        LD A,(DUCKY)                    ;DUCKY->a
        INC A                           ;a+1->a
rdec:					;return from decrement
        LD (DUCKY),A                    ;a->DUCKY
        RET                             ;return to main body
inca:
        LD A,(DUCKX)                    ;DUCKX->a
        INC A                           ;a+1->a
        JR rinc                         ;return from increment
deca:
        LD A,(DUCKY)                    ;DUCKY->a
        DEC A                           ;a-1->a
        JR rdec                         ;return from decrement

PutMove:
        CALL PutGun                     ;re-display crosshairs

SkipDelay:

        LD A,(MOVES)                    ;MOVES->a
        CP 200                          ;has the duck moved # times?
        JP Z,flyaway                    ;if so, fly away

        CALL LoadDuck                   ;Load Duck
        CALL DrawDuck                   ;Draw the Duck
        JR chWING

WINGch:                                 ;return from chWING. (Wing status changed)
        JR chkdloc                      ;check duck's location (if on any edges,
					;change movement direction.)
rchk:					;return from check
        CALL dmove                      ;move duck!
        JP Loop                         ;go to beginning of duck moving routine


; o Change WING (up or down) o
chWING:
        LD A,(WING)                     ;WING->a
        INC A                           ;a+1->a
        LD (WING),a                     ;a->WING

        CP 3                            ;is a 3?
        JR NZ,WINGch                    ;if not, goto WING changed (it must be 2)

        LD A,1                          ;(else, reset WING to 1)... 1->a
        LD (WING),A                     ;a->WING
        JP WINGch                       ;return from chWING


; o Check duck's location o
chkdloc:

        LD A,(DUCKX)                    ;DUCKX->a (duck's x-coord)

        CP 87                           ;is x-coord 87?
        JR Z,chDIRLR                    ;if so, goto change duck's lr direction

        CP 1                            ;is x-coord 1?
        JR Z,chDIRLR                    ;if so, goto change duck's lr direction

nchk:
        LD A,(DUCKY)                    ;DUCKY->a (duck's y-coord)

        CP 1                            ;is y-coord 1?
        JR Z,chDIRUD                    ;if so, goto change duck's ud direction

        CP 38                           ;is y-coord 38?
        JR Z,chDIRUD                    ;if so, goto change duck's ud direction

        JR rchk

chDIRLR:                                ;change duck's lr movement
        LD A,(DIRLR)                    ;DIRLR->a
        INC A                           ;a+1->a
        LD (DIRLR),A                    ;a->DIRLR

        CP 3                            ;is DIRLR 3?
        JR NZ,nchk                      ;if not, next chk (that means DIRLR is 2)

        LD A,1                          ;(otherwise... set it back to 1) 1->a
        LD (DIRLR),A                    ;a->DIRLR

        JR nchk                         ;next check chk

chDIRUD:                                ;change duck's ud movement
        LD A,(DIRUD)                    ;DIRUD->a
        INC A                           ;a+1->a
        LD (DIRUD),a                    ;a->DIRUD

        CP 3                            ;is DIRUD 3?
        JR NZ,rchk                      ;if not, return (that means DIRUD is 2)

        LD A,1                          ;(otherwise... set it back to 1) 1->a
        LD (DIRUD),a                    ;a->DIRUD
        JR rchk                         ;return from chk


; o Load which sprite (direction and WING up or down) o
LoadDuck:
        LD A,(WING)                     ;WING->a
        CP 2                            ;WING down?
        JR Z,down                       ;if so,jump to down

        LD A,(DIRLR)                    ;DIRLR->a
        CP 2                            ;left?
        JR Z,uleft                      ;if so, jump to (facing) up,left

        LD IX,drwu                      ;if none of these, sprite drwu->bc=20
        RET                             ;duck loaded

uleft:
        LD IX,dlwu                      ;sprite dlwu->bc
        RET                             ;duck loaded
down:
        LD A,(DIRLR)                    ;DIRLR->a
        CP 2                            ;left?
        JR Z,dleft                      ;if so,jump to (facing) down,left

        LD IX,drwd                      ;otherwise, sprite drwd->bc
        RET                             ;jp duckldd
dleft:
        LD IX,dlwd                      ;sprite dlwd->bc
        RET                             ;jp duckldd


; o Put Gun o
PutGun:
        LD IX,gun                       ;sprite gun->IX
        CALL DrawGun                    ;Draw the Gun
        bcall(_copygbuf)                ;Copy graph buffer to screen
        RET                             ;return

; o Put Duck o
PutDuck:
        CALL LoadDuck
        CALL DrawGun                    ;Draw the Gun
        bcall(_copygbuf)                ;Copy graph buffer to screen
        RET                             ;return


; o ROUND over o
rndovr:

        RES 7,(IY+$14)                  ;
        bcall(CLEARLCD)                 ;Clear LCD

        LD HL,10*256+10                 ;penrow=20,pencol=10
        LD (CURSOR_X),HL                ;set these coords

        ;Show how many hit/NEEDED

        LD HL,youhit                    ;"You hit "
        bcall(D_ZM_STR)                 ;put STRING on graph
        LD A,(DHIT)                     ;# ducks hit->a
        CALL DispA
        LD HL,andneed                   ;" and NEEDED "
        bcall(D_ZM_STR)                 ;put STRING on graph
        LD A,(NEEDED)                   ;# NEEDED to advance->a
        CALL DispA

        ;Check for ROUND clear!

        LD A,(DHIT)                     ;# NEEDED to advance->a
        INC A                           ;Increase it, so that if they are =, it works out
        LD B,A
        LD A,(NEEDED)
        CP B
        JP NC,exit

        ;If you've made it here, ROUND CLEAR!

        LD HL,20*256+28                 ;penrow=30,pencol=28
        LD (CURSOR_X),HL                ;set these coords
        LD HL,rndclr                    ;"Round Clear!"
        bcall(D_ZM_STR)                 ;put STRING on graph!

        LD A,(DHIT)                     ;# ducks hit->a
        CP 10                           ;did you hit all 10 ducks?
        JR NZ,noperfect                 ;if not skip perfect, goto NOPERFECT!

        LD HL,(SCORE)                   ;SCORE->hl
        LD DE,250
        ADD HL,DE
        LD (SCORE),HL                   ;hl->SCORE

        LD HL,34                        ;penrow=0,pencol=34
        LD (CURSOR_X),HL                ;set coords
        LD HL,perfect                   ;"PERFECT!"
        bcall(D_ZM_STR)

        LD HL,00*256+21                 ;penrow=10,pencol=21
        LD (CURSOR_X),HL                ;set coords
        LD HL,bonus                     ;"100 point BONUS!"
        bcall(D_ZM_STR)

noperfect:
        CALL Pause                      ;Wait for a key
        LD B,4 \ CALL Delay             ;Delay

        LD A,(ROUND)                    ;ROUND #->a
        CP 5                            ;ROUND #5?
        JR Z,winner                     ;if so, you win!

        INC A                           ;a+1->a
        LD (ROUND),A                    ;a->ROUND
        CALL ReSetDelay

        JP NewRound                     ;new ROUND!!!

; o WINNER! o
winner:

        bcall(CLEARLCD)                 ;Clear the Screen

        LD HL,7                         ;penrow=0,pencol=7
        LD (CURSOR_X),HL                ;set these coords
        LD HL,congrats                  ;first line of congrats STRING
        bcall(D_ZM_STR)

        LD DE,6*256+9                   ;penrow=6,pencol=9
        LD (CURSOR_X),DE                ;set these coords
        bcall(D_ZM_STR)                 ;second line of congrats STRING

        LD DE,12*256+14                 ;penrow=12,pencol=14
        LD (CURSOR_X),DE                ;set these coords
        bcall(D_ZM_STR)                 ;third line of congrats STRING

        LD DE,18*256                    ;penrow=18,pencol=0
        LD (CURSOR_X),DE                ;set these coords
        bcall(D_ZM_STR)                 ;fourth line of congrats STRING

; o Exit o
exit:
        RES 7,(IY+$14)                  ;

        LD HL,40*256+30                 ;penrow=29,pencol=33
        LD (CURSOR_X),HL                ;set these coords
        LD HL,gameover                  ;"GAME OVER!"
        bcall(D_ZM_STR)                 ;put STRING on graph!

        LD HL,47*256+30                 ;penrow=37,pencol=30
        LD (CURSOR_X),HL                ;set these coords
        LD HL,scr                       ;"SCORE = "
        bcall(D_ZM_STR)                 ;put STRING on graph!

        LD HL,47*256+50                 ;penrow=37,pencol=30
        LD (CURSOR_X),HL                ;set these coords
        LD HL,(SCORE)                   ;SCORE->hl
        CALL DispHL                     ;Display it!

        CALL Pause                      ;Wait for a key

        LD HL,(SCORE)                   ;final SCORE
        LD DE,(HighScore)               ;load high SCORE
        bcall(CP_HL_DE)                 ;compare SCORE w/ hi SCORE
        JR C,NoNewHS                    ;score is less

        bcall(CLEARLCD)                 ;Clear LCD

        SBC HL,HL                       ;HL=0
        LD (CURSOR_X),HL
        LD HL,hiscr
        bcall(D_ZM_STR)                 ;Display "A new HS"

        LD HL,79
        LD (CURSOR_X),HL
        LD HL,(SCORE)
        LD (HighScore),HL               ;Save new high score
        CALL dispHL

        CALL EnterPName                 ;Get player name

NoNewHS:
        bcall(CLEARLCD)
        RET                             ;Return to Ion


; o Set Delay o

ReSetDelay:
        LD A,(ROUND)

        CP 2
        JR Z,LoadDelay2

        LD HL,$900
        JR PutDelay

LoadDelay2:
        LD HL,$1400

PutDelay:
        LD (DLAY),HL
        RET


; o Initialize new ROUND stuff o
nrInit:                         

        bcall(CLEARLCD)                 ;clear screen

        LD A,44
        LD (GUNX),A
        LD A,20
        LD (GUNY),A
        LD A,1
        LD (CURDUCK),A
        XOR A
        LD (DHIT),A

        
;        LD HL,nrInitVar                 ;
;        LD DE,GUNX                      ;
;        LD BC,4                         ;
;        LDIR                            ;Init new round var

        LD A,(ROUND)                    ;ROUND->a
        LD B,5                          ;5->b
        ADD A,B                         ;a+b->a
        LD (NEEDED),A                   ;a->NEEDED

        LD HL,20*256+35                 ;penrow=20,pencol=35
        LD (CURSOR_X),HL                ;set these coords
        LD HL,rnd                       ;"Round "
        bcall(D_ZM_STR)

        LD HL,20*256+60
        LD (CURSOR_X),HL
        LD A,(ROUND)                    ;ROUND->a
        CALL DispA                      ;display a at penrow,pencol

        LD HL,30*256+15                 ;penrow=30,pencol=15
        LD (CURSOR_X),HL                ;set these coords
        LD HL,hits                      ;hit STRING "Hit "
        bcall(D_ZM_STR)                 ;put STRING on graph!

        LD HL,30*256+27
        LD (CURSOR_X),HL
        LD A,(NEEDED)                   ;NEEDED->a
        CALL DispA

        LD HL,30*256+34
        LD (CURSOR_X),HL 
        LD HL,outof10                   ;" out of 10 ducks!"
        bcall(D_ZM_STR)                 ;put STRING on graph!

        bcall(_copygbuf)                ;Copy graph buffer to screen
        RES 7,(IY+$14)

        CALL Pause                      ;Wait for a key
        LD B,3 \ CALL Delay             ;Delay
        RET                             ;done,return from new ROUND initialize



; o Initialize new duck stuff o
ndInit:                        

        CALL PutBG                      ;Put background

        LD A,3                          ;3->a
        LD (BULLETS),A                  ;a->BULLETS
        LD A,1                          ;1->a
        LD (WING),A                     ;a->WING
        LD (MOVES),A                    ;a->MOVES
        LD (DIRUD),A                    ;a->DIRUD
        LD A,37                         ;37->a
        LD (DUCKY),A                    ;a->DUCKY

        LD B,85                         ;85->B  (85 is max num for random)
        CALL ionRandom                  ;Random routine
        INC A
        LD (DUCKX),A                    ;a->DUCKX (a contains the random #)

        LD B,2                          ;2->B (2 is max num for random)
        CALL ionRandom                  ;Random routine
        INC A
        LD (DIRLR),A                    ;a->DIRLR

        LD HL,57*256+26                 ;penrow=3D57,pencol=3D26
        LD (CURSOR_X),HL                ;set those coords
        LD A,(CURDUCK)                  ;current duck->a
        CALL DispA

        LD HL,57*256+43                 ;penrow=3D57,pencol=3D43
        LD (CURSOR_X),HL                ;set those coords
        LD A,(DHIT)                     ;ducks hit->a
        CALL DispA

        bcall(_copygbuf)                ;Copy graph buffer to screen

        CALL PutGun                     ;Put the gun

        RET


; o Init var o
varInit:
        SBC HL,HL                       ;0->hl
        LD (SCORE),HL                   ;hl->SCORE

        LD A,1                          ;1->a
        LD (ROUND),a                    ;a->current ROUND (1 to start)

        LD HL,$2100                     ;initial delay length (2100)->hl
        LD (DLAY),HL                    ;hl->DLAY

        RET
 

; o Put Background o
PutBG:

        bcall(_cleargbuf)               ;Clear Graph Mem

        LD DE,bg                        ;
        LD HL,graph_mem                 ;
        CALL DecodeZCP                  ;Decompress background

        bcall(_copygbuf)                ;Copy graph buffer to screen
        RET
	

; o Delay o
Delay:
	PUSH AF		
        PUSH DE  

DelayLoop1:
        LD DE,(DLAY)

DelayLoop2:
        DEC DE   
        LD A,D   
        OR E             
        JR NZ,DelayLoop2

        DJNZ DelayLoop1

        POP DE
	POP AF		
        RET


; o Shoot gun! o
shoot:
        CALL PutGun
        LD IX,shot                      ;sprite shot->ix
        CALL DrawGun                    ;Draw the Gun
        bcall(_copygbuf)                ;Copy graph buffer to screen

        LD B,3 \ CALL Delay             ;Delay

        LD IX,shot                      ;sprite shot->ix
        CALL DrawGun                    ;Draw the Gun
        bcall(_copygbuf)                ;Copy graph buffer to screen        

        CALL PutGun

erasebul:

        LD A,(BULLETS)                  ;BULLETS->a
        SLA A \ SLA A                   ;A*=4
        LD L,A \ LD H,0

        LD DE,56*256
        ADD HL,DE
        LD (CURSOR_X),HL                ;Cursor position

        LD HL,erase                     ;STRING erase->hl
        bcall(D_ZM_STR)                 ;display STRING on graph (erasing bullet)


; o Check for hit 
CheckForHit:

        LD A,(GUNX)                     ;Loads Gun X into A
        ADD A,4                         ;Add 8 to A [End of Sprite]
        LD B,A                          ;Loads A into B
        LD A,(DUCKX)                    ;Loads Duck X into A
        CP B                            ;Compares a to b
        JR C,ContinueCheck              ;Continue Checking if a>b

        JP subbull                      ;Missed Otherwise
       
ContinueCheck:
        LD A,(DUCKX)                    ;Duck X into A
        ADD A,4                         ;Add 8 to A [End of Sprite]
        LD B,A                          ;Loads A into B
        LD A,(GUNX)                     ;Gun X into A
        CP B                            ;Compare A to B
        JR C,CheckYHit                  ;If b>a then check Y-Coord

        JP subbull                      ;You missed otherwise

CheckYHit:
        LD A,(GUNY)                     ;Loads Gun X into A
        ADD A,4                         ;Add 8 to A [End of Sprite]
        LD B,A                          ;Loads A into B
        LD A,(DUCKY)                    ;Loads Duck X into A
        CP B                            ;Compares a to b
        JR C,ContinueCheckY             ;Continue Checking if a>b

        JP subbull                      ;Missed Otherwise
                                   
ContinueCheckY:
        LD A,(DUCKY)                    ;Duck X into A
        ADD A,4                         ;Add 8 to A [End of Sprite]
        LD B,A                          ;Loads A into B
        LD A,(GUNY)                     ;Gun X into A
        CP B                            ;Compare A to B
        JP C,hit                        ;If b>a then Hit!!!

        JP subbull                      ;You missed otherwise


; o Erase duck and cursor o
erdc:
        CALL PutGun                     ;xor crosshairs on screen (erasing them)
        CALL LoadDuck                   ;Loads the Duck
        CALL DrawDuck                   ;Draw the Duck
        bcall(_copygbuf)                ;Copy graph buffer to screen        
        RET


; o Display A/HL o
DispA:
        
        LD H,0 \ LD L,A                 ;HL=A

DispHL:
        PUSH DE \ PUSH HL

        LD DE,STRING+5
        XOR A
        LD (DE),A
Repeat:
        bcall(UNPACK_HL)
        ADD A,$30
        DEC DE
        LD (DE),A

        LD A,H
        OR L
        JR NZ,Repeat

        EX DE,HL
        bcall(D_ZM_STR)

        POP HL \ POP DE
        RET


; o Wait for key ENTER o
Pause:

        bcall(GET_KEY)

        CP G_ENTER
        JR NZ,Pause
        RET


; o Display the introduction o
Intro:
        CALL InitIntroScreen            ;Init intro screen

        LD DE,$0003                     ;
        LD HL,TitleStuff2               ;
        CALL Aff_B_Lgn                  ;Authors

        CALL Pause                      ;Wait for a key

        CALL InitIntroScreen            ;Init intro screen

        LD DE,$0303                     ;
        LD HL,Ctrl                      ;
        CALL Aff_B_Lgn                  ;Controls

        LD HL,$3A00                     ;
        LD (CURSOR_X),HL                ;
        LD HL,HighScoreStr              ;
        bcall(D_ZM_STR)                 ;
                                        ;
        LD A,6                          ;
        bcall(M_CHARPUT)                ;
                                        ;
        LD HL,(HighScore)               ;
        CALL DispHL                     ; High Score

        RET



; o Display "DuckHunt 83" in invert mode
InitIntroScreen:

        bcall(CLEARLCD)                 ;Clear screen

        SET 3,(IY+$05)
        SBC HL,HL                       ;HL=0
        LD (CURSOR_ROW),HL
        LD HL,TitleStuff
        bcall(D_ZT_STR)
        RES 3,(IY+$05)                 ;Display title
        RET


; o Display <B> lines o
Aff_B_Lgn:

        LD B,3                          ;Number of lines
        LD (CURSOR_ROW),DE              ;

Aff_B_Lgn_Boucle:
        bcall(D_ZT_STR)

        INC DE
        LD (CURSOR_ROW),DE

        DJNZ Aff_B_Lgn_Boucle
        RET


; o Draw the duck (in graph mem) o
DrawDuck:
        LD A,(DUCKY)                    ;Duck Y Coordinate into A
        LD L,A                          ;That into L
        LD A,(DUCKX)                    ;Duck X into A
        LD B,8
        CALL ionPutSprite               ;Display sprite
        RET


; o Draw the gun (in graph mem) o
DrawGun:
        LD A,(GUNY)                     ;Gun Y Coordinate into A
        LD L,A                          ;That into L
        LD A,(GUNX)                     ;Gun X into A
        LD B,8
        CALL ionPutSprite               ;Display sprite
        RET


; o Enter the player name (From Elem) o
EnterPName:

        ;Clear name
        LD HL,HighSName      
        PUSH HL              
        LD B,8               

ClearName:
        LD (HL),0               
        INC HL      
        DJNZ ClearName

        POP DE                
        
SaisieCar:

        LD HL,$0404                     ;Show buffer
        LD (CURSOR_ROW),HL
        LD HL,HighSName      
        bcall(D_ZT_STR)

        LD A,226                        ;Show 'Alpha symbol'
        bcall(TX_CHARPUT)
        LD A,$20
        bcall(TX_CHARPUT)

Pres_Touche:

        PUSH DE
        bcall(GET_KEY)                  ;GetKey
        POP DE

        OR A                            ;
        JR Z,Pres_Touche                ;No key press

        CP G_ENTER                      ;
        JR Z,Fin_Saisie                 ;Key=Enter (Name is ok)

        CP G_DEL                        ;
        JR Z,Efface                     ;Key=Del (Delete a char)

        LD HL,Touches        
        LD BC,28             

        CPIR                 

        LD A,C               

        OR A                 
        JR Z,Pres_Touche     

        ADD A,63

        PUSH DE \ POP HL                ;HL=DE
        LD BC,HighSName      
        SBC HL,BC              

        LD B,A                 
        LD A,8 
        CP L                   
        JR Z,SaisieCar         

        LD A,B
        LD (DE),A
        INC DE                  

        JR SaisieCar            

Efface:

        ;Delete a char

        LD HL,HighSName       
        bcall(CP_HL_DE)
        JR Z,SaisieCar        

        DEC DE                
        XOR A
        LD (DE),A             

        JR SaisieCar          

Fin_Saisie:
        RET


; o Keyboard port stuff o
KeyStuff:
        LD A,$FF                        ;Reset keyport
        OUT (1),a                       ;Clear Port
        LD A,B                          ;Load desired port
        OUT (1),A                       ;Clear Keys
        IN A,(1)                        ;Input Key
        RET


; o Include DecompZCP o

        .INCLUDE ZCPDECOD.ASM



; o BackGround (ZCP) o
bg      .DB $3F,$3F,$3F,$82,$D0,$3F,$17,$D5,$3F,$19,$D5,$A0,$3F,$14,$D5,$A0,$3F,$12
        .DB $D5,$A0,$3F,$14,$D5,$3F,$1B,$F4,$3F,$1C,$F0,$3F,$1B,$C0,$3F,$18,$D0,$3F
        .DB $1B,$E0,$3F,$1B,$C0,$3F,$1A,$C0,$94,$3F,$13,$E0,$AA,$3F,$12,$D4,$AA,$C0
        .DB $3F,$0B,$D5,$AA,$D0,$3F,$0D,$D4,$AA,$C0,$3F,$0B,$D5,$AA,$D0,$3F,$0D,$D4
        .DB $AA,$C0,$3F,$0E,$E3,$C0,$3F,$13,$E7,$3F,$14,$D1,$CC,$3F,$14,$D3,$D8,$3F
        .DB $12,$D5,$F8,$3F,$14,$D3,$E5,$A0,$3F,$0B,$D3,$F5,$A8,$3F,$0D,$C7,$95,$A8
        .DB $3F,$0C,$E7,$8A,$D0,$3F,$0D,$EE,$AA,$D0,$3A,$FC,$0A,$FE,$95,$A0,$39,$FA
        .DB $0C,$FE,$84,$3D,$FC,$E0,$80,$FE,$8C,$3D,$F0,$B0,$08,$FC,$F0,$3B,$E1,$88
        .DB $0A,$48,$3F,$E1,$A2,$0B,$FE,$3F,$B0,$80,$C0,$83,$E0,$3E,$E4,$81,$0B,$F8
        .DB $3F,$B1,$C0,$C0,$83,$F0,$3E,$E0,$99,$0A,$FE,$3F,$9C,$88,$A0,$83,$F8,$3F
        .DB $B4,$86,$0A,$FE,$3F,$8F,$83,$C0,$83,$F8,$81,$88,$C0,$82,$88,$81,$88,$A1
        .DB $92,$4D,$80,$C7,$F5,$C2,$91,$94,$D5,$94,$82,$98,$D2,$C4,$DF,$FA,$C3,$BF
        .DB $D3,$A9,$D4,$CB,$AC,$D3,$A9,$F5,$CA,$A3,$FE,$C9,$9D,$FF,$A5,$E6,$F4,$AD
        .DB $B5,$AD,$E7,$D6,$D5,$C4,$E6,$C4,$FB,$FB,$B7,$9A,$D2,$D9,$D5,$A3,$9F,$9A
        .DB $D6,$F3,$DA,$AD,$AF,$F5,$DA,$DE,$EB,$EE,$D5,$DA,$D5,$EA,$FB,$AB,$AD,$B7
        .DB $48,$AD,$FD,$FE,$ED,$B5,$B5,$FD,$F6,$D7,$DF,$DF,$ED,$BB,$49,$B7,$BB,$DD
        .DB $F5,$EF,$B7,$BE,$DD,$D6,$F7,$BB,$D5,$4C,$B5,$BA,$D7,$AF,$EF,$B5,$BD,$FD
        .DB $F6,$D7,$BB,$EC,$0E,$7F,$51,$95,$93,$D8,$1E,$FE,$AC,$CC,$F0,$0E,$F4,$D5
        .DB $93,$B2,$DA,$C8,$D5,$E3,$FA,$A5,$AA,$D0,$0C,$F2,$F5,$93,$AA,$D3,$80,$F4
        .DB $C3,$F9,$A5,$B3,$13,$F4,$D2,$93,$B3,$DA,$C8,$D4,$C3,$FA,$B2,$AB,$D0,$0C
        .DB $F0,$0C,$E0,$1C,$FE,$23,$F1,$CC,$E3,$94,$0A,$C0,$09,$FE,$23,$F1,$CC,$E3
        .DB $BE,$1A,$FE,$23,$F0,$0C,$E5,$0C,$C0,$09,$FE,$23,$F1,$CC,$E3,$BE,$1A,$FE
        .DB $23,$F0,$0C,$E5,$0C,$C0,$09,$FE,$23,$55,$21,$FE,$23,$E0,$00

; o Sprites o

drwu    .DB     01000000b               ;duck facing right, WING up
        .DB     01100011b               
        .DB     00110100b
        .DB     01111000b
        .DB     11110000b
        .DB     01000000b
        .DB     00000000b
        .DB     00000000b

drwd    .DB     00000011b               ;duck facing right, WING down
        .DB     00000100b
        .DB     01111000b
        .DB     11111000b
        .DB     01001100b
        .DB     00000000b
        .DB     00000000b
        .DB     00000000b

dlwu    .DB     00000010b               ;duck facing left, WING up
        .DB     11000110b
        .DB     00101100b
        .DB     00011110b
        .DB     00001111b
        .DB     00000010b
        .DB     00000000b
        .DB     00000000b

dlwd    .DB     11000000b               ;duck facing left, WING down
        .DB     00100000b
        .DB     00011110b
        .DB     00011111b
        .DB     00110010b
        .DB     00000000b
        .DB     00000000b
        .DB     00000000b

gun     .DB     00000000b               ;sprite for crosshairs
        .DB     00000000b
        .DB     00100100b
        .DB     00011000b
        .DB     00011000b
        .DB     00100100b
        .DB     00000000b
        .DB     00000000b

shot    .DB     00000000b               ;gunshot mark on screen
        .DB     01000010b
        .DB     00101000b
        .DB     00010100b
        .DB     00101100b
        .DB     00010010b
        .DB     01001000b
        .DB     00000000b

faway   .DB     00001000b               ;duck fly away
        .DB     00001000b
        .DB     00011100b
        .DB     00111110b
        .DB     01101011b
        .DB     00101010b
        .DB     00010100b
        .DB     00000000b

hitduck .DB     00000100b               ;falling duck
        .DB     00010100b
        .DB     00011110b
        .DB     00011110b
        .DB     00011100b
        .DB     00001000b
        .DB     00001000b
        .DB     00000000b


; o Var o

; o Title stuff o
TitleStuff      .DB "   DuckHunt 83  ",0

TitleStuff2     .DB "Andrew Ungvarsky",0
                .DB " Ahmed El-Helw",0
                .DB "      Kaid",0


; o Controls stuff o
Ctrl            .DB "2ND  Shoot",0
                .DB "DEL  Pause",0
                .DB "MODE Quit",0


; o HighScore stuff o
HighScoreStr    .DB "High: " 
HighSName       .DB "--------",0
HighScore       .DW 0


erase           .DB "  ",0                      ;STRING to erase bullet
fas             .DB "Fly Away!",0               ;fly away STRING
rnd             .DB "Round ",0                  ;ROUND # STRING
hits            .DB "Hit ",0
outof10         .DB " out of 10 ducks!",0
rndclr          .DB "Round Clear!",0
youhit          .DB "You hit ",0
andneed         .DB " and NEEDED ",0
prsclr          .DB "(Press Clear)",0
gameover        .DB "GAME OVER",0
congrats        .DB "Congratulations! You are",0
                .DB "a hunting machine. BUT,",0
                .DB "since I hate hunting,",0
                .DB "there's no cool ending. SORRY!",0
scr             .DB "SCORE = ",0
perfect         .DB "PERFECT!",0
bonus           .DB "250 point BONUS!",0
HiScr           .DB "A New High Score!",0


; o Round init var (gun x-coord,gun y-coord,curduck,dhit) o
nrInitVar       .DB 44,20,1,0


; o List of keys to enter player name *
Touches         .DB G_2
                .DB G_1
                .DB G_STO
                .DB G_MINUS
                .DB G_6
                .DB G_5
                .DB G_4
                .DB G_LN
                .DB G_STAR
                .DB G_9
                .DB G_8
                .DB G_7
                .DB G_LOG
                .DB G_SLASH
                .DB G_RIGHTPAR
                .DB G_LEFTPAR
                .DB G_COMMA
                .DB G_SQUARE
                .DB G_RAISE
                .DB G_TAN
                .DB G_COS
                .DB G_SIN
                .DB G_INV
                .DB G_PRGM
                .DB G_MATRIX
                .DB G_MATH
                .DB G_DEL


.END
